﻿using System;

namespace MonteCarloMethod
{
    internal class Program
    {
        public void MonteCarloIntegrationExample()
        {
            int hitCount;
            int sampleCount;
            double width = 9;
            double height = 5;
            sampleCount = 100;
            hitCount = 0;
            double area = 0;
            double xCoord = 0;
            double yCoord = 0;

            Random rand = new Random();
            for (int i = 0; i < sampleCount; i++)
            {
                xCoord = width * rand.NextDouble();
                yCoord = height * rand.NextDouble();

                if (xCoord / 3 < yCoord && yCoord < xCoord * (10 - xCoord) / 5)
                {
                    hitCount++;
                }
            }
            area = width * height * hitCount / sampleCount;
            Console.WriteLine("Результат примера: " + area);
        }

        public void MonteCarloIntegration1()
        {
            int hitCount;
            int sampleCount;
            double width = 15;
            double height = 1;
            sampleCount = 100;
            hitCount = 0;
            double area = 0;
            double xCoord = 0;
            double yCoord = 0;

            Random rand = new Random();

            for (int i = 0; i < sampleCount; i++)
            {
                xCoord = width * rand.NextDouble();
                yCoord = height * rand.NextDouble();
                if (0 < yCoord && (Math.Sin(xCoord) < yCoord))
                {
                    hitCount++;
                }
            }
            area = width * height * hitCount / sampleCount;
            Console.WriteLine("Результат 1 задачи: " + area);
        }

        public void MonteCarloIntegration2()
        {
            int hitCount;
            int sampleCount;
            double width = 8;
            double height = 8;
            sampleCount = 100;
            hitCount = 0;
            double area = 0;
            double xCoord = 0;
            double yCoord = 0;

            Random rand = new Random();

            for (int i = 0; i < sampleCount; i++)
            {
                xCoord = width * rand.NextDouble();
                yCoord = height * rand.NextDouble();

                if ((xCoord / 2) < yCoord && yCoord < (xCoord * (8 - xCoord)) / 2)
                {
                    hitCount++;
                }
            }
            area = width * height * hitCount / sampleCount;
            Console.WriteLine("Результат 2 задачи: " + area);
        }

        public void MonteCarloIntegration3()
        {
            int hitCount;
            int sampleCount;
            double width = 12;
            double height = 6;
            sampleCount = 100;
            hitCount = 0;
            double area = 0;
            double xCoord = 0;
            double yCoord = 0;

            Random rand = new Random();

            for (int i = 0; i < sampleCount; i++)
            {
                xCoord = width * rand.NextDouble();
                yCoord = height * rand.NextDouble();

                if ((Math.Pow(xCoord - 6, 2)) / 6 < yCoord && yCoord < 6)
                {
                    hitCount++;
                }
            }
            area = width * height * hitCount / sampleCount;
            Console.WriteLine("Результат 3 задачи: " + area);
        }

        public void MonteCarloIntegration4()
        {
            int hitCount;
            int sampleCount;
            double width = 11;
            double height = 4;
            sampleCount = 100;
            hitCount = 0;
            double area = 0;
            double xCoord = 0;
            double yCoord = 0;

            Random rand = new Random();

            for (int i = 0; i < sampleCount; i++)
            {
                xCoord = width * rand.NextDouble();
                yCoord = height * rand.NextDouble();

                if ((xCoord / 5) < yCoord && yCoord < (xCoord * (12 - xCoord)) / 9)
                {
                    hitCount++;
                }
            }
            area = width * height * hitCount / sampleCount;
            Console.WriteLine("Результат 4 задачи: " + area);
        }

        public void MonteCarloIntegration5()
        {
            int hitCount;
            int sampleCount;
            double width = 8;
            double height = 4;
            sampleCount = 100;
            hitCount = 0;
            double area = 0;
            double xCoord = 0;
            double yCoord = 0;

            Random rand = new Random();

            for (int i = 0; i < sampleCount; i++)
            {
                xCoord = width * rand.NextDouble();
                yCoord = height * rand.NextDouble();

                if (((8 - xCoord) / 8) < yCoord && yCoord < ((xCoord * (8 - xCoord)) / 4))
                {
                    hitCount++;
                }
            }
            area = width * height * hitCount / sampleCount;
            Console.WriteLine("Результат 5 задачи: " + area);
        }

        public void MonteCarloIntegration6()
        {
            int hitCount;
            int sampleCount;
            double width = 3;
            double height = 1;
            sampleCount = 100;
            hitCount = 0;
            double area = 0;
            double xCoord = 0;
            double yCoord = 0;

            Random rand = new Random();

            for (int i = 0; i < sampleCount; i++)
            {
                xCoord = width * rand.NextDouble();
                yCoord = height * rand.NextDouble();

                if (((Math.Pow(xCoord - 2, 2)) / 2) < yCoord && yCoord < Math.Sin(xCoord))
                {
                    hitCount++;
                }
            }
            area = width * height * hitCount / sampleCount;
            Console.WriteLine("Результат 6 задачи: " + area);
        }

        public void CalculatePi(int totalPoints)
        {
            int insideCircle = 0;
            Random rand = new Random();

            for (int i = 0; i < totalPoints; i++)
            {
                double x = rand.NextDouble();
                double y = rand.NextDouble();
                if (x * x + y * y <= 1)
                {
                    insideCircle++;
                }
            }

            double piEstimate = 4.0 * insideCircle / totalPoints;
            Console.WriteLine("Приблизительное значение числа пи: " + piEstimate);
        }

        static void Main(string[] args)
        {
            Program program = new Program();
            Console.Write("Введите количество точек для вычисления числа пи: ");
            if (int.TryParse(Console.ReadLine(), out int totalPoints))
            {
                program.CalculatePi(totalPoints);
            }
            else
            {
                Console.WriteLine("Некорректный ввод. Пожалуйста, введите целое число.");
            }
            program.MonteCarloIntegrationExample();
            program.MonteCarloIntegration1();
            program.MonteCarloIntegration2();
            program.MonteCarloIntegration3();
            program.MonteCarloIntegration4();
            program.MonteCarloIntegration5();
            program.MonteCarloIntegration6();
            Console.ReadKey();
        }
    }
}
